/* Console Emulation by NoNameNo
 */ 

#include <psl1ght/lv2.h>

#include <math.h>
#include <stdarg.h>
#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <assert.h>
#include <unistd.h>

#include <sysutil/video.h>
#include <rsx/gcm.h>
#include <rsx/reality.h>

#include <io/pad.h>


int FONTSIZE=2;

#include <font.h>


typedef struct{char *title; u8 *data; u32 data_size; int typeym;} typeliste;

gcmContextData *context;

VideoResolution res;

int currentBuffer = 0;
s32 *buffer[2];


u32 ansicol[]={0x000000,0x0000aa,0x00aa00,0x00aaaa,0xaa0000,0xaa00aa,0xaa5500,0xaaaaaa,0x555555,0x5555ff,0x55ff55,0x55ffff,0xff5555,0xff55ff,0xffff55,0xffffff};

char charbuf[80][25];
int fcbuf[80][25];
int bcbuf[80][25];
int curXpos=0;
int curYpos=0;
int bkpXpos=0;
int bkpYpos=0;
int curFC=0xf;
int curBC=0x0;

void waitFlip() {
	while(gcmGetFlipStatus() != 0){
		usleep(200);
	}
	gcmResetFlipStatus();
}

void flip(s32 buffer) {
	assert(gcmSetFlip(context, buffer) == 0);
	realityFlushBuffer(context);
	gcmSetWaitFlip(context);
}



void init_screen() {
	int x,y;
	void *host_addr = memalign(1024*1024, 1024*1024);
	assert(host_addr != NULL);

	context = realityInit(0x10000, 1024*1024, host_addr);
	assert(context != NULL);

	VideoState state;
	assert(videoGetState(0, 0, &state) == 0);
	assert(state.state == 0);

	assert(videoGetResolution(state.displayMode.resolution, &res) == 0);

	VideoConfiguration vconfig;
	memset(&vconfig, 0, sizeof(VideoConfiguration));
	vconfig.resolution = state.displayMode.resolution;
	vconfig.format = VIDEO_BUFFER_FORMAT_XRGB;
	vconfig.pitch = res.width * 4;

	assert(videoConfigure(0, &vconfig, NULL, 0) == 0);
	assert(videoGetState(0, 0, &state) == 0);

	s32 buffer_size = 4 * res.width * res.height;
	printf("buffers will be 0x%x bytes\n", buffer_size);

	gcmSetFlipMode(GCM_FLIP_VSYNC);

	buffer[0] = rsxMemAlign(16, buffer_size);
	buffer[1] = rsxMemAlign(16, buffer_size);
	assert(buffer[0] != NULL && buffer[1] != NULL);

	u32 offset[2];
	assert(realityAddressToOffset(buffer[0], &offset[0]) == 0);
	assert(realityAddressToOffset(buffer[1], &offset[1]) == 0);

	assert(gcmSetDisplayBuffer(0, offset[0], res.width * 4, res.width, res.height) == 0);
	assert(gcmSetDisplayBuffer(1, offset[1], res.width * 4, res.width, res.height) == 0);

	gcmResetFlipStatus();
	flip(1);

	for(y=0;y<25;y++){
		for(x=0;x<80;x++){
			charbuf[x][y]=0;
			fcbuf[x][y]=curFC;
			bcbuf[x][y]=curBC;
		}
	}
}


void GRRLIB_FillScreen(u32 color){
	int *buf = buffer[currentBuffer];

	memset(buf,color,1920*1080*4);
}

void GRRLIB_PutPixel(int x,int y, u32 color){
   int *buf = buffer[currentBuffer];

	buf[y* res.width + x] = color;
}

void GRRLIB_PrintChar(int x, int y, int bcolor, int fcolor, char chartoprint){
	int j,i;
	int prov=0;

	x=((1920-80*9*FONTSIZE)/2)+x*9*FONTSIZE;
	y=((1080-25*16*FONTSIZE)/2)+y*16*FONTSIZE;

	for(j=0;j<16*FONTSIZE;j++){
        	for(i=0;i<9*FONTSIZE;i++){
			if(FONTSIZE==1)
				prov = font[j][i+chartoprint*9*FONTSIZE];
			else if(FONTSIZE==2)
				prov = font2[j][i+chartoprint*9*FONTSIZE];

                	if(prov){
				if(fcolor !=16)
		                        GRRLIB_PutPixel(x+i,y+j,ansicol[fcolor]);
			}
			else{
				if(bcolor !=16)
		                        GRRLIB_PutPixel(x+i,y+j,ansicol[bcolor]);
			}
                }
	}
}

void  GRRLIB_Printf (const char *text, ...) {
    int x,y;
    int i, size;
    char tmp[1024];
    char current_character;
    char next_character;
    char ansi_sequence[15];
    char ansi_sequence_character;
    int ansi_sequence_loop;

    int aint1=0;
    int aint2=0;

    va_list argp;
    va_start(argp, text);
    size = vsnprintf(tmp, sizeof(tmp), text, argp);
    va_end(argp);


    for (i = 0; i < size; i++) {
	current_character=tmp[i];
	next_character=tmp[i+1];

	if((curXpos > 79) && (curYpos !=24)){
		curXpos=0;
		curYpos++;
	}
	else if((curXpos > 79) && (curYpos ==24)){
		//tout remonter
	}
	else if((curXpos < 0) && (curYpos !=0)){
		curXpos=79;
		curYpos--;
	}
	else if((curXpos < 0) && (curYpos ==0)){
		curXpos=0;
		curYpos=0;
	}

	if(curYpos < 0){
		curYpos=0;
	}
	if(curYpos > 24){
		//tout Remonter
	}

/*****************************************************************************/
/* CR+LF                                                                     */
/*****************************************************************************/
	if(current_character == 13){
		if(next_character == 10){
			curXpos=0;
			curYpos++;
			i+=1;
		}
	}

/*****************************************************************************/
/* LF                                                                        */
/*****************************************************************************/
	if(current_character == 10){
		curXpos=0;
		curYpos++;

	}
/*****************************************************************************/
/* TAB                                                                       */
/*****************************************************************************/
	if(current_character == 9){
                curXpos+=8;
        }
/*****************************************************************************/
/* SUB                                                                       */
/*****************************************************************************/
	if (current_character == 26){
		break;
	}

	if (current_character==27 && next_character==91){
        	strcpy(ansi_sequence,"");
		for (ansi_sequence_loop=0;ansi_sequence_loop<12;ansi_sequence_loop++){
			ansi_sequence_character=tmp[i+2+ansi_sequence_loop];

/*****************************************************************************/
/* CURSOR POSITION                                                           */
/*****************************************************************************/
			if (ansi_sequence_character=='H' || ansi_sequence_character=='f'){
				i+=ansi_sequence_loop+2;
				sscanf(ansi_sequence,"%d;%d",&aint1,&aint2);
				curXpos=aint2;
				curYpos=aint1;
				break;
			}

/*****************************************************************************/
/* CURSOR UP                                                                 */
/*****************************************************************************/
			if (ansi_sequence_character=='A'){
				if (ansi_sequence==NULL){
					strcpy(ansi_sequence,"1");
				}
				i+=ansi_sequence_loop+2;
				sscanf(ansi_sequence,"%d",&aint1);
				curYpos=curYpos-aint1;
				break;
			}

/*****************************************************************************/
/* CURSOR DOWN                                                               */
/*****************************************************************************/
			if (ansi_sequence_character=='B'){
				if (ansi_sequence==NULL){
					strcpy(ansi_sequence,"1");
				}
				i+=ansi_sequence_loop+2;
				sscanf(ansi_sequence,"%d",&aint1);
				curYpos=curYpos+aint1;
				break;
			}

/*****************************************************************************/
/* CURSOR FORWARD                                                            */
/*****************************************************************************/
			if (ansi_sequence_character=='C'){
				if (ansi_sequence==NULL){
					strcpy(ansi_sequence,"1");
				}
				i+=ansi_sequence_loop+2;
				sscanf(ansi_sequence,"%d",&aint1);
				curXpos=curXpos+aint1;
				if(curXpos>79) curXpos=79;
				break;
			}

/*****************************************************************************/
/* CURSOR BACKWARD                                                           */
/*****************************************************************************/
			if (ansi_sequence_character=='D'){
				if (ansi_sequence==NULL){
					strcpy(ansi_sequence,"1");
				}
				i+=ansi_sequence_loop+2;
				sscanf(ansi_sequence,"%d",&aint1);
				curXpos=curXpos-aint1;
				if(curXpos<0) curXpos=0;
				break;
			}

/*****************************************************************************/
/* SAVE CURSOR POSITION                                                      */
/*****************************************************************************/
			if (ansi_sequence_character=='s'){
				i+=ansi_sequence_loop+2;
				bkpXpos=curXpos;
				bkpYpos=curYpos;
				break;
			}

/*****************************************************************************/
/* RESTORE CURSOR POSITION                                                   */
/*****************************************************************************/
			if (ansi_sequence_character=='u'){
				i+=ansi_sequence_loop+2;
				curXpos=bkpXpos;
				curYpos=bkpYpos;
				break;
			}

/*****************************************************************************/
/* ERASE DISPLAY                                                             */
/*****************************************************************************/
			if (ansi_sequence_character=='J'){
				if (ansi_sequence==NULL){
					strcpy(ansi_sequence,"0");
				}
				sscanf(ansi_sequence,"%d",&aint1);

				if (aint1==2){
					for(y=0;y<25;y++){
						for(x=0;x<80;x++){
							charbuf[x][y]=0;
							fcbuf[x][y]=curFC;
							bcbuf[x][y]=curBC;
						}
					}
					curXpos=0;
					curYpos=0;
				}
				i+=ansi_sequence_loop+2;
				break;
			}


			strcat(ansi_sequence,&ansi_sequence_character);
		}
	}
	else if(current_character!=10 && current_character!=13 && current_character!=9){
		charbuf[curXpos][curYpos]=tmp[i];
		fcbuf[curXpos][curYpos]=curFC;
		bcbuf[curXpos][curYpos]=curBC;
		curXpos++;
	}

    }
}

void GRRLIB_DrawConsole(void){
	int x,y;

	for(y=0;y<25;y++){
		for(x=0;x<80;x++){
			GRRLIB_PrintChar(x, y, bcbuf[x][y], fcbuf[x][y], charbuf[x][y]);
		}
	}
}


s32 main(s32 argc, const char* argv[])
{
	init_screen();

	PadInfo padinfo;
	PadData paddata;
	int i;

	ioPadInit(7);

	GRRLIB_FillScreen(0x000000);
	curFC=0xf;
	GRRLIB_Printf("\033[10;10HTest it ;)");

	while(1){
		ioPadGetInfo(&padinfo);
		for(i=0; i<MAX_PADS; i++){
			if(padinfo.status[i]){
				ioPadGetData(i, &paddata);

				if(paddata.BTN_START){
					return 0;
				}
			}
		}

		waitFlip(); 
		GRRLIB_DrawConsole();
		flip(currentBuffer);
		currentBuffer = !currentBuffer;

	}

	return 0;
}

